function [totalVol] = rectangleIntersectVolumes(pitXS, pitZ, pitMinY, pitMaxY, grainLongRad, grainShortRad)

realX = min(pitXS, grainShortRad);
realZ = min(pitZ, grainShortRad);

pitMinY = grainLongRad+pitMinY;
pitMaxY = grainLongRad+pitMaxY;

if pitMinY>=2*grainLongRad || pitMaxY<=0 % grain and pit don't overlap
    realY = 0;
elseif pitMinY<=0 && pitMaxY>=2*grainLongRad % entire grain is in pit
    realY = grainLongRad*2;
elseif pitMinY>0 && pitMaxY<2*grainLongRad % entire pit is in grain
    realY = pitMaxY-pitMinY;
elseif pitMinY>0 && pitMaxY>=2*grainLongRad % pit extends beyond grainMax
    realY = grainLongRad*2-pitMinY;
elseif pitMinY<=0 && pitMaxY<2*grainLongRad % pit extends beyond grainMin
    realY = pitMaxY;
else
    error('This should''ve covered all positibilities')
end

totalVol = realX*realY*realZ;

end

